function [] = main(x)
   switch x
      case 'original' 
	 selfreplicate(1);               
      case 'replicate'
	 selfreplicate(0);
      case ''
	 disp('Hello world');
      otherwise
	 makeselfrep(x);
   end
   quit;
end

function [] = PRINT1(x)
   fprintf('%s',char(x));
end

function [] = PRINT2(n,x)
   fprintf([n '=\'''';\n']);
   i = 1;
   l = 15;
   while i <= length(x)
      m = min(i+l-1,length(x));
      fprintf('%s=[%s',n,n);
      fprintf(' %d',x(i:m));
      fprintf('];\n');
      i = m+1;
   end
end

function [] = printselfrepprog(x,y,mode)
   PRINT1(x);
   if mode == 0
      PRINT2('A',x);
      PRINT2('B',y);
   end
   PRINT1(y);
end

function [m] = getmarker()
   m = ['This' ' is the marker'];
end

function [] = selfreplicate(mode)
   % This is the marker
   printselfrepprog(A,B,mode);
end

function [] = makeselfrep(f)
   A = [];
   B = [];
   fd = fopen(f,'r');
   marker = getmarker();

   while 1
      line = fgets(fd);
      A = [A double(line)];
      if length(strfind(line,marker)) > 0
	 break;
      end
   end

   while 1
      line = fgets(fd);
      if line == -1
	 break;
      end
      %B = [B double(line)];
      B = [B line];
   end
   B = [B '\n'];

   printselfrepprog(A,B,0);
end
